<xsl:stylesheet xmlns:xsl = "http://www.w3.org/1999/XSL/Transform" 
                version ="1.0"          
                xmlns:exsl="http://exslt.org/common"
                extension-element-prefixes="exsl">

<xsl:variable name="testindexdir">dbaron.org/css/test/xml</xsl:variable>
<xsl:variable name="testindex"><xsl:value-of select="$testindexdir"/>/list.html.xml</xsl:variable>

<xsl:template match="/">
  <xsl:apply-templates select="document($testindex)" mode="index"/>
</xsl:template>

<xsl:template match="text()" mode="index"/>

<xsl:template match="a" mode="index">
  <xsl:if test="not(contains(@href,'/'))">
    <xsl:call-template name="maketestfile">
      <xsl:with-param name="ref" select="@href"/>
    </xsl:call-template>
  </xsl:if>
</xsl:template>

<xsl:template name="maketestfile">
  <xsl:param name="ref"/>
  <xsl:variable name="srcurl"><xsl:value-of select="$testindexdir"/>/<xsl:value-of select="$ref"/>.xml</xsl:variable>
  <xsl:apply-templates mode="proctest" select="document($srcurl)">
    <xsl:with-param name="ref" select="$ref"/>
  </xsl:apply-templates>
</xsl:template>


<xsl:template match="head" mode="proctest">
  <xsl:param name="ref"/>
  <xsl:message>
     <xsl:value-of select="title"/>
  </xsl:message>
  <xsl:variable name="the_dst">csstests/<xsl:value-of select="$ref"/>/<xsl:value-of select="$ref"/>.css</xsl:variable>
  <exsl:document href="{$the_dst}" 
    method="text">
    <xsl:value-of select="style"/>
  </exsl:document>
</xsl:template>

<xsl:template match="body" mode="proctest">
  <xsl:param name="ref"/>
  <xsl:variable name="the_dst">csstests/<xsl:value-of select="$ref"/>/<xsl:value-of select="$ref"/>.xml</xsl:variable>
  <exsl:document href="{$the_dst}" 
      method="xml" 
      version="1.0" 
      encoding="iso-8859-1" 
      indent="yes">
    <xsl:processing-instruction name="xml-stylesheet">type="text/css" href="<xsl:value-of select="$ref"/>.css"</xsl:processing-instruction>
    <xsl:text>
    </xsl:text>
    <test-document>
      <xsl:apply-templates mode="proctest"/>
    </test-document>
  </exsl:document>
</xsl:template>

<xsl:template match="body/pre[1]" mode="proctest"/>
<xsl:template match="body/h1[1]" mode="proctest"/>

<xsl:template match="body/*" mode="proctest">
  <xsl:if test="following-sibling::hr[@title='Beginning of Footer'] and not(following-sibling::PRE)">
    <xsl:copy-of select="."/>
  </xsl:if>
</xsl:template>

</xsl:stylesheet>
